@echo off
SETLOCAL 
REM ##################################################################
REM # IBM Confidential
REM #
REM # OCO Source Materials
REM #
REM # --SA4.1_PID--
REM # Copyright IBM Corp. 2005, 2006,2007
REM # The source code for this program is not published or otherwise
REM # divested of its trade secrets, irrespective of what has
REM # been deposited with the U.S. Copyright Office.
REM #
REM ###################################################################
REM # Module: configure_nsbound
REM # Description: Configure the TBSM North-South interface

REM NOTE: This script is structured using gotos and labels rather than 
REM         nested IFs because I couldn't get them to work. Brackets in
REM         echo statements were interpreted as closing the IFs. Escaping
REM         those brackets with ^ takes care of that issue, but then for
REM         some reason SET statements weren't working inside a nested IF.
REM         In the end I felt it would be a better use of time to just 
REM         rewrite using gotos and labels.
REM
REM       So beware of introducing nested IFs into this script if you
REM         don't have workarounds for this issue.  

    SET CMD=%~n0
    SET LOGFILE=%CMD%.%RANDOM%.log
    
    SET UNINSTALL_NS=NO
    if "%1"=="-remove" (
        SET UNINSTALL_NS=YES
        goto switchesokay
    )
    REM if no switch provided then install
    if "%1"=="" (
        goto switchesokay
    )
    
    REM if got here a switch was provided but not recognised
    echo Invalid switch: %1
    echo Usage: %CMD% [ -remove ]
    EXIT /B 1

:switchesokay

    SET TBSM_HOME=%TBSM_HOME%
    SET TIP_HOME=%TIP_HOME%
    SET TIP_PROFILE=TIPProfile
    SET TBSM_PROFILE=TBSMProfile
    SET TIP_USER=tipadmin
    
    SET SA_USER=--SA_USER--
    SET SQMHOST=--SQM_HOST--
    SET LDAPHOST=--LDAPHOST--
    SET WASHOST=--WASHOST--
    SET LDAPSPORT=--LDAPSPORT--
    SET LDAPROOT=--LDAPROOT--
    SET SQMLDAP_PASSWD=--SQMLDAP_PASSWD--
    SET ISC_PORT=--ISC_PORT--
    
    SET LDAPBASE=ou=People,%LDAPROOT%
    SET ODADRIVER_JAR=com.ibm.tnsqm.reports.kqihistory.odadriver.jar
    SET CHART_FILE=kqihistory-chart.rptdesign
    SET SLO_CHART_FILE=slokqihistory-chart.rptdesign
    SET WAR_FILE=report_launcher.war
    SET FILE_LOCATION=%CD%
    SET CHART_FILE_LOCATION=%CD%

    SET /P TBSM_HOME="Enter TBSM Home (%TBSM_HOME%): "
    IF NOT EXIST "%TBSM_HOME%" (
        echo ERROR: "%TBSM_HOME%" not found.
        EXIT /B 1
    )
    IF EXIST "%TBSM_HOME%"\setupTBSMData.bat (
        CALL "%TBSM_HOME%"\setupTBSMData.bat
    )
    IF EXIST "%TBSM_HOME%"\setupTBSMDash.bat (
        CALL "%TBSM_HOME%"\setupTBSMDash.bat
    )
    
    SET /P TIP_HOME="Enter TIP Home (%TIP_HOME%): "
    IF NOT EXIST "%TIP_HOME%" (
        echo ERROR: "%TIP_HOME%" not found.
        EXIT /B 1
    )
    
    SET LOG_DIR=%TIP_HOME%\logs\tnsqmlogs
    
    IF EXIST "%TIP_HOME%\profiles\%TIP_PROFILE%" (
        SET /P TIP_USER="Enter TIP User name (%TIP_USER%): "
        
        SET /P TIP_PASSWD="Please enter password for user (%TIP_USER%): "
        REM Accept empty password, but need to reset ERRORLEVEL with a good command
        IF ERRORLEVEL 1 CD > NUL
    )
    
    IF "%UNINSTALL_NS%"=="NO" (
        goto install
    )
    REM else we're UNINSTALLing
    IF "%UNINSTALL_NS%"=="YES" (
        goto uninstall
    )
 
:install

    IF NOT EXIST "%TIP_HOME%\profiles\%TBSM_PROFILE%\bin\startServer.bat" (
        goto skipchartscheck
    )
    REM else install charts
    SET /P CHART_FILE_LOCATION="Enter KQI history chart location (%CHART_FILE_LOCATION%): "
    IF NOT EXIST "%CHART_FILE_LOCATION%\%CHART_FILE%" (
        echo ERROR: "%CHART_FILE_LOCATION%\%CHART_FILE%" not found.
        EXIT /B 1
    )
    IF NOT EXIST "%CHART_FILE_LOCATION%\%SLO_CHART_FILE%" (
        echo ERROR: "%CHART_FILE_LOCATION%\%SLO_CHART_FILE%" not found.
        EXIT /B 1
    )

:skipchartscheck

    IF NOT EXIST "%TIP_HOME%\profiles\%TIP_PROFILE%\bin\startServer.bat" (
        goto skipcodecheck
    )
    REM else install code
    SET /P FILE_LOCATION="Enter ODA driver jar and report launcher war file location (%FILE_LOCATION%): "
    IF NOT EXIST "%FILE_LOCATION%\%ODADRIVER_JAR%" (
        echo ERROR: "%FILE_LOCATION%\%ODADRIVER_JAR%" not found.
        EXIT /B 1
    )
    IF NOT EXIST "%FILE_LOCATION%\%WAR_FILE%" (
        echo ERROR: "%FILE_LOCATION%\%WAR_FILE%" not found.
        EXIT /B 1
    )

:skipcodecheck

    REM Create logging dir. Only if doesn't exist (error otherwise)
    IF NOT EXIST "%LOG_DIR%" (
        echo Creating logging directory %LOG_DIR% ...
        mkdir "%LOG_DIR%"
        IF ERRORLEVEL 1 (
            echo ERROR: Failed to create directory: "%LOG_DIR%".
            EXIT /B 1
        )
        echo done.
    )     

    IF NOT EXIST "%TIP_HOME%\profiles\%TBSM_PROFILE%\bin\startServer.bat" (
        echo TBSM data server not installed
        goto skipchartsinstall
    )
    REM else install charts
    echo Copying "%CHART_FILE%"... 
    copy "%FILE_LOCATION%\%CHART_FILE%" "%TIP_HOME%\profiles\%TBSM_PROFILE%\installedApps\TBSMCell\tbsm.ear\sla.war\birtcharts\custom\"
    IF ERRORLEVEL 1 (
        echo ERROR: Copy of "%FILE_LOCATION%\%CHART_FILE%" failed.
        EXIT /B 1
    )
    echo done.
    
    echo Copying "%SLO_CHART_FILE%"... 
    copy "%FILE_LOCATION%\%SLO_CHART_FILE%" "%TIP_HOME%\profiles\%TBSM_PROFILE%\installedApps\TBSMCell\tbsm.ear\sla.war\birtcharts\custom\"
    IF ERRORLEVEL 1 (
        echo ERROR: Copy of "%FILE_LOCATION%\%SLO_CHART_FILE%" failed.
        EXIT /B 1
    )
    echo done.
        
:skipchartsinstall

    IF NOT EXIST "%TIP_HOME%\profiles\%TIP_PROFILE%\bin\startServer.bat" (
        echo TBSM dashboard server not installed
        goto skipcodeinstall
    )
            
    echo Updating wsjaas.conf... 
    SET WSJAAS_CONF=%TIP_HOME%\profiles\%TIP_PROFILE%\properties\wsjaas.conf
    REM echoing to non-existent file doesn't change ERRORLEVEL, so just make sure file exists
    IF NOT EXIST "%WSJAAS_CONF%" (
        echo ERROR: "%WSJAAS_CONF%" not found.
        EXIT /B 1
    )

    echo Backing up wsjaas.conf... 
    copy %WSJAAS_CONF% %WSJAAS_CONF%.bak
    IF ERRORLEVEL 1 (
        echo ERROR: Copy of "%WSJAAS_CONF%" to "%WSJAAS_CONF%.bak" failed.
        EXIT /B 1
    )    
    
    >> "%WSJAAS_CONF%" echo CTAUTHENTICATION {
    >> "%WSJAAS_CONF%" echo    com.comnitel.jaas.ldap.LdapLoginModule required
    >> "%WSJAAS_CONF%" echo    com.comnitel.security.auth.factory="com.sun.jndi.ldap.LdapCtxFactory"
    >> "%WSJAAS_CONF%" echo    com.comnitel.security.auth.server="ldaps://%LDAPHOST%:%LDAPSPORT%"
    >> "%WSJAAS_CONF%" echo    com.comnitel.security.authentication="simple";
    >> "%WSJAAS_CONF%" echo }; 
    
    echo done.
            
    echo Creating WSADMIN Jython script... 
    REM need to escape slashes in log path
    SET LOG_DIR_ESCAPED=%LOG_DIR:\=\\%
    
    SET CONFIG_WSADMIN_FILE=setProps%RANDOM%.py
    >> "%CONFIG_WSADMIN_FILE%" echo jvm = AdminConfig.list^('JavaVirtualMachine'^)
    >> "%CONFIG_WSADMIN_FILE%" echo. 
    >> "%CONFIG_WSADMIN_FILE%" echo # Have to break out properties otherwise command runs over 256 chars in length and fails
    >> "%CONFIG_WSADMIN_FILE%" echo. 
    >> "%CONFIG_WSADMIN_FILE%" echo userProp = ["com.comnitel.security.auth.username","%SA_USER%"]
    >> "%CONFIG_WSADMIN_FILE%" echo passwordProp = ["com.comnitel.security.auth.password","%SQMLDAP_PASSWD%"]
    >> "%CONFIG_WSADMIN_FILE%" echo ldapServerProp = ["com.comnitel.security.auth.server","ldaps://%LDAPHOST%:%LDAPSPORT%"]
    >> "%CONFIG_WSADMIN_FILE%" echo authPatternProp = ["com.comnitel.security.auth.pattern","uid={0},%LDAPBASE%"]
    >> "%CONFIG_WSADMIN_FILE%" echo logDir = ["comnitel.log.basedir","%LOG_DIR_ESCAPED%\\"]
    >> "%CONFIG_WSADMIN_FILE%" echo sqmConfRoot = ["com.comnitel.config.root","https://%WASHOST%:%ISC_PORT%/ibm/sa_services/conf/"]
    >> "%CONFIG_WSADMIN_FILE%" echo appName = ["application.name","tnsqmreports"]
    >> "%CONFIG_WSADMIN_FILE%" echo jvmCustomProperties = [ userProp, passwordProp , ldapServerProp, authPatternProp, logDir, sqmConfRoot, appName]
    >> "%CONFIG_WSADMIN_FILE%" echo. 
    >> "%CONFIG_WSADMIN_FILE%" echo # Copy into system JVM properties
    >> "%CONFIG_WSADMIN_FILE%" echo attr = []
    >> "%CONFIG_WSADMIN_FILE%" echo for prop in jvmCustomProperties:
    >> "%CONFIG_WSADMIN_FILE%" echo    attr.append^([['name', prop[0]], ['value', prop[1]]]^)
    >> "%CONFIG_WSADMIN_FILE%" echo. 
    >> "%CONFIG_WSADMIN_FILE%" echo AdminConfig.modify^(jvm, [['systemProperties', attr]]^)
    >> "%CONFIG_WSADMIN_FILE%" echo AdminConfig.save^(^)
    >> "%CONFIG_WSADMIN_FILE%" echo. 
    
    REM echoing to non-existent file doesn't change ERRORLEVEL, so just make sure file now exists
    IF NOT EXIST "%CONFIG_WSADMIN_FILE%" (
        echo ERROR: Creation of temporary Jython script "%CONFIG_WSADMIN_FILE%" failed.
        EXIT /B 1
    )
    echo done.
    
    echo Running WSADMIN Jython code... 
    CALL "%TIP_HOME%"\bin\wsadmin.bat -lang jython -profileName %TIP_PROFILE% -username %TIP_USER% -password %TIP_PASSWD% -f "%CONFIG_WSADMIN_FILE%"
    IF ERRORLEVEL 1 (
        echo ERROR: WSADMIN Jython execution failed.
        EXIT /B 1
    )
    echo done.
    
    echo Tidying WSADMIN Jython script... 
    del "%CONFIG_WSADMIN_FILE%"
    IF ERRORLEVEL 1 (
        echo ERROR: Deletion of temporary Jython script "%CONFIG_WSADMIN_FILE%" failed.
        EXIT /B 1
    )
    echo done.
    
    echo Copying "%ODADRIVER_JAR%"...
    copy "%FILE_LOCATION%\%ODADRIVER_JAR%" "%TIP_HOME%\systemApps\isclite.ear\TIPChartPortlet.war\WEB-INF\platform\plugins\"
    IF ERRORLEVEL 1 (
        echo ERROR: Copy of "%ODADRIVER_JAR%" failed.
        EXIT /B 1
    )
    echo done.
    
    echo Copying "%WAR_FILE%"...     
    IF NOT EXIST "%TIP_HOME%"\systemApps\isclite.ear\report_launcher.war (
        echo Creating report launcher directory "%TIP_HOME%"\systemApps\isclite.ear\report_launcher.war ...
        mkdir "%TIP_HOME%"\systemApps\isclite.ear\report_launcher.war
        IF ERRORLEVEL 1 (
            echo ERROR: Failed to create directory: "%TIP_HOME%"\systemApps\isclite.ear\report_launcher.war.
            EXIT /B 1
        )
        echo done.
    )    
    copy "%FILE_LOCATION%\"%WAR_FILE% "%TIP_HOME%"\systemApps\isclite.ear\report_launcher.war
    pushd "%TIP_HOME%"\systemApps\isclite.ear\report_launcher.war
    "%TIP_HOME%"\java\bin\jar xf "%TIP_HOME%"\systemApps\isclite.ear\report_launcher.war\%WAR_FILE%
    popd 
    del "%TIP_HOME%"\systemApps\isclite.ear\report_launcher.war\%WAR_FILE%
    echo done.    

    SET CONFIG_WSADMIN_PROFILE_FILE=configProfile%RANDOM%.jacl
    echo Creating temporary JACL script in %CONFIG_WSADMIN_PROFILE_FILE%...
    
    >> "%CONFIG_WSADMIN_PROFILE_FILE%" echo $AdminApp update isclite modulefile {-operation add -contents "%FILE_LOCATION%\%WAR_FILE%" -contenturi report_launcher.war -contextroot /ibm/report_launcher -MapWebModToVH {{.* .* admin_host}}}
    >> "%CONFIG_WSADMIN_PROFILE_FILE%" echo $AdminConfig save
    >> "%CONFIG_WSADMIN_PROFILE_FILE%" echo. 
     
    REM echoing to non-existent file doesn't change ERRORLEVEL, so just make sure file now exists
    IF NOT EXIST "%CONFIG_WSADMIN_PROFILE_FILE%" (
        echo ERROR: Creation of temporary JACL script "%CONFIG_WSADMIN_PROFILE_FILE%" failed.
        EXIT /B 1
    )
    echo done.
    
    echo Updating %TIP_PROFILE% configuration... 
    CALL "%TIP_HOME%"\bin\wsadmin.bat -lang jacl -profileName %TIP_PROFILE% -username %TIP_USER% -password %TIP_PASSWD% -f "%CONFIG_WSADMIN_PROFILE_FILE%"
    IF ERRORLEVEL 1 (
        echo ERROR: WSADMIN JACL execution failed.
        EXIT /B 1
    )
    echo done.
        
    echo Tidying WSADMIN JACL script... 
    del "%CONFIG_WSADMIN_PROFILE_FILE%"
    IF ERRORLEVEL 1 (
        echo ERROR: Deletion of temporary JACL script "%CONFIG_WSADMIN_PROFILE_FILE%" failed.
        EXIT /B 1
    )
    echo done.

:skipcodeinstall
        
    REM finished INSTALLing
    echo Stopping TIP...
    CALL "%TIP_HOME%"\profiles\%TIP_PROFILE%\bin\stopServer.bat server1 -profileName %TIP_PROFILE% -username %TIP_USER% -password %TIP_PASSWD% >> "%LOGFILE%"
    IF ERRORLEVEL 1 (
        echo ERROR: TIP stop failed.
        EXIT /B 1
    )
    echo done. 
                
    goto restartTIP

:uninstall

    IF NOT EXIST "%TIP_HOME%\profiles\%TBSM_PROFILE%\bin\startServer.bat" (
        echo TBSM data server not installed
        goto skipchartsuninstall
    )
    
    echo Removing charts...    
    del "%TIP_HOME%\profiles\%TBSM_PROFILE%\installedApps\TBSMCell\tbsm.ear\sla.war\birtcharts\custom\%CHART_FILE%"
    IF ERRORLEVEL 1 (
        echo ERROR: Deletion of chart "%TIP_HOME%\profiles\%TBSM_PROFILE%\installedApps\TBSMCell\tbsm.ear\sla.war\birtcharts\custom\%CHART_FILE%" failed.
        EXIT /B 1
    )
    del %TIP_HOME%\profiles\%TBSM_PROFILE%\installedApps\TBSMCell\tbsm.ear\sla.war\birtcharts\custom\%SLO_CHART_FILE%"
    IF ERRORLEVEL 1 (
        echo ERROR: Deletion of chart "%TIP_HOME%\profiles\%TBSM_PROFILE%\installedApps\TBSMCell\tbsm.ear\sla.war\birtcharts\custom\%SLO_CHART_FILE%" failed.
        EXIT /B 1
    )
    echo done.

:skipchartsuninstall
        
    IF NOT EXIST "%TIP_HOME%\profiles\%TIP_PROFILE%\bin\startServer.bat" (
        echo TBSM dashboard server not installed
        goto skipcodeuninstall
    )
            
    SET CONFIG_WSADMIN_PROFILE_FILE=configProfile%RANDOM%.jacl
    echo Creating temporary JACL script in %CONFIG_WSADMIN_PROFILE_FILE% ...
    
    >> "%CONFIG_WSADMIN_PROFILE_FILE%" echo $AdminApp update isclite modulefile {-operation delete -contenturi report_launcher.war}
    >> "%CONFIG_WSADMIN_PROFILE_FILE%" echo $AdminConfig save
    >> "%CONFIG_WSADMIN_PROFILE_FILE%" echo. 
     
    REM echoing to non-existent file doesn't change ERRORLEVEL, so just make sure file now exists
    IF NOT EXIST "%CONFIG_WSADMIN_PROFILE_FILE%" (
        echo ERROR: Creation of temporary JACL script "%CONFIG_WSADMIN_PROFILE_FILE%" failed.
        EXIT /B 1
    )
    echo done.
    
    echo Updating %TIP_PROFILE% configuration... 
    CALL "%TIP_HOME%"\bin\wsadmin.bat -lang jacl -profileName %TIP_PROFILE% -username %TIP_USER% -password %TIP_PASSWD% -f "%CONFIG_WSADMIN_PROFILE_FILE%"
    IF ERRORLEVEL 1 (
        echo ERROR: WSADMIN JACL execution failed.
        EXIT /B 1
    )
    echo done.
        
    echo Tidying WSADMIN JACL script... 
    del "%CONFIG_WSADMIN_PROFILE_FILE%"
    IF ERRORLEVEL 1 (
        echo ERROR: Deletion of temporary JACL script "%CONFIG_WSADMIN_PROFILE_FILE%" failed.
        EXIT /B 1
    )
    echo done.

    REM need to stop TIP before removing jar on Windows       
    echo Stopping TIP...
    CALL "%TIP_HOME%"\profiles\%TIP_PROFILE%\bin\stopServer.bat server1 -profileName %TIP_PROFILE% -username %TIP_USER% -password %TIP_PASSWD% >> "%LOGFILE%"
    IF ERRORLEVEL 1 (
        echo ERROR: TIP stop failed.
        EXIT /B 1
    )
    echo done. 
    
    echo "Removing reports JAR...
    del "%TIP_HOME%\systemApps\isclite.ear\TIPChartPortlet.war\WEB-INF\platform\plugins\%ODADRIVER_JAR%"
    IF ERRORLEVEL 1 (
        echo ERROR: Deletion of file "%TIP_HOME%\systemApps\isclite.ear\TIPChartPortlet.war\WEB-INF\platform\plugins\%ODADRIVER_JAR%" failed.
        EXIT /B 1
    )
    echo done.
    
    echo Removing report launcher WAR...
    rmdir /S /Q "%TIP_HOME%\systemApps\isclite.ear\report_launcher.war
    echo done.
        
    echo Restoring wsjaas.conf... 
    SET WSJAAS_CONF=%TIP_HOME%\profiles\%TIP_PROFILE%\properties\wsjaas.conf
    REM Try copy .bak file back over
    IF NOT EXIST "%WSJAAS_CONF%.bak" (
        echo WARNING: "%WSJAAS_CONF%.bak" not found. Please remove the        
        echo following stanza from "%WSJAAS_CONF%" and restart TIP.
        echo CTAUTHENTICATION {
        echo   com.comnitel.jaas.ldap.LdapLoginModule required
        echo   com.comnitel.security.auth.factory="com.sun.jndi.ldap.LdapCtxFactory"
        echo   com.comnitel.security.auth.server="ldaps://%LDAPHOST%:%LDAPSPORT%"
        echo   com.comnitel.security.authentication="simple";
        echo };
        EXIT /B 1
    )
    MOVE /Y "%WSJAAS_CONF%.bak" "%WSJAAS_CONF%"

    REM finished UNINSTALLing    
    goto restartTIP

:restartTIP

    echo Starting TIP... 
    
    CALL "%TIP_HOME%"\profiles\%TIP_PROFILE%\bin\startServer.bat server1 -profileName %TIP_PROFILE% -username %TIP_USER% -password %TIP_PASSWD% >> "%LOGFILE%"
    IF ERRORLEVEL 1 (
        echo ERROR: TIP start failed.
        EXIT /B 1
    )

:skipcodeuninstall
    
    echo done. Configuration complete - see "%LOGFILE%" for details.
    
    ENDLOCAL
    EXIT /B 0


